#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) (ll)(x).size()

using ll = long long;
using ld = long double;

constexpr ll inf = 1000000000000000000;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll n;
	cin >> n;
	vector<pair<ll, ll>> in(n);
	for (ll i = 0; i < n; i++) {
		ll t, x;
		cin >> t >> x;
		in[i] = {t, x};
	}
	sort(all(in));
	auto ok = [&](ll m){
		ll l = -inf;
		ll r = inf;
		ll lastT = 0;
		for (auto e : in) {
			ll dt = e.first - lastT;
			r = min(r + dt, e.second);
			l = max(l - dt, e.second-m);
			if (l > r) return false;
			lastT = e.first;
		}
		return true;
	};
	ll l = 0;
	ll r = 999999999998;
	while (l + 1  < r) {
		ll m = (l + r) / 2;
		if (ok(m)) {
			r = m;
		} else {
			l = m;
		}
	}
	cout << r << endl;
}
 